#undef TRACEPOINT_PROVIDER
#define TRACEPOINT_PROVIDER examplelib

#if !defined( TP_EXAMPLELIB_H ) || defined( TRACEPOINT_HEADER_MULTI_READ )
#define TP_EXAMPLELIB_H

#include <lttng/tracepoint.h>

#include "RouterTX/Traits.h"
#include "RouterTX/Messages.h"

TRACEPOINT_EVENT(
   examplelib,
   wtf,
   TP_ARGS(
   int, lineno_arg,
   char const *, text_arg,
   uint64_t, value_arg
      ),
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_string( text, text_arg )
      ctf_integer( uint64_t, value, value_arg )
      )
   )

TRACEPOINT_EVENT(
   examplelib,
   wtf3,
   TP_ARGS(
   int, lineno_arg,
   char const *, text_arg,
   uint64_t, param1_arg,
   uint64_t, param2_arg
      ),
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_string( text, text_arg )
      ctf_integer( uint64_t, param1, param1_arg )
      ctf_integer( uint64_t, param2, param2_arg )
      )
   )

TRACEPOINT_LOGLEVEL( examplelib, wtf, TRACE_ERR )
TRACEPOINT_LOGLEVEL( examplelib, wtf3, TRACE_ERR )

TRACEPOINT_EVENT(
   examplelib,
   submit_ack,
   TP_ARGS(
      int, lineno_arg,
      uint64_t, siid_arg,
      sr4::RouterTX::AckSubmitExtRouter const *, msg
      ),
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_integer( uint64_t, siid, siid_arg )
      ctf_integer( uint64_t, iid, msg->iid() )
      ctf_integer( uint64_t, cid, msg->cid() )
      ctf_integer( uint64_t, tid, msg->tid() )
      ctf_integer( uint64_t, eoid, msg->eoid() )
      ctf_integer( uint64_t, side, msg->side() )
      ctf_integer( uint64_t, limit_price, msg->limit_price() )
      ctf_integer( uint64_t, stop_price, msg->stop_price() )
      ctf_integer( uint64_t, working_qty, msg->working_qty() )
      ctf_integer( uint64_t, show_qty, msg->show_qty() )
      ctf_integer( uint64_t, transact_time, msg->transact_time() )
      )
   )

TRACEPOINT_EVENT(
   examplelib,
   submit_nack,
   TP_ARGS(
      int, lineno_arg,
      uint64_t, siid_arg,
      sr4::RouterTX::NakSubmit const *, msg
      ),
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_integer( uint64_t, siid, siid_arg )
      ctf_integer( uint64_t, iid, msg->iid() )
      ctf_integer( uint64_t, cid, msg->cid() )
      ctf_integer( uint64_t, tid, msg->tid() )
      ctf_integer( uint64_t, side, msg->side() )
      ctf_integer( uint64_t, limit_price, msg->limit_price() )
      ctf_integer( uint64_t, stop_price, msg->stop_price() )
      ctf_integer( uint64_t, show_qty, msg->show_qty() )
      ctf_integer( uint64_t, transact_time, msg->transact_time() )
      )
   )

TRACEPOINT_EVENT(
   examplelib,
   modify_ack,
   TP_ARGS(
      int, lineno_arg,
      uint64_t, siid_arg,
      sr4::RouterTX::AckModifyExtRouter const *, msg
      ),
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_integer( uint64_t, siid, siid_arg )
      ctf_integer( uint64_t, iid, msg->iid() )
      ctf_integer( uint64_t, cid, msg->cid() )
      ctf_integer( uint64_t, tid, msg->tid() )
      ctf_integer( uint64_t, eoid, msg->eoid() )
      ctf_integer( uint64_t, side, msg->side() )
      ctf_integer( uint64_t, limit_price, msg->limit_price() )
      ctf_integer( uint64_t, stop_price, msg->stop_price() )
      ctf_integer( uint64_t, show_qty, msg->show_qty() )
      ctf_integer( uint64_t, working_qty, msg->working_qty() )
      ctf_integer( uint64_t, transact_time, msg->transact_time() )
      )
   )

TRACEPOINT_EVENT(
   examplelib,
   modify_nack,
   TP_ARGS(
      int, lineno_arg,
      uint64_t, siid_arg,
      sr4::RouterTX::NakModify const *, msg
      ),
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_integer( uint64_t, siid, siid_arg )
      ctf_integer( uint64_t, iid, msg->iid() )
      ctf_integer( uint64_t, cid, msg->cid() )
      ctf_integer( uint64_t, tid, msg->tid() )
      ctf_integer( uint64_t, eoid, msg->eoid() )
      ctf_integer( uint64_t, side, msg->side() )
      ctf_integer( uint64_t, limit_price, msg->limit_price() )
      ctf_integer( uint64_t, stop_price, msg->stop_price() )
      ctf_integer( uint64_t, working_qty, msg->working_qty() )
      ctf_integer( uint64_t, transact_time, msg->transact_time() )
      )
   )

TRACEPOINT_EVENT(
   examplelib,
   cancel_ack,
   TP_ARGS(
      int, lineno_arg,
      uint64_t, siid_arg,
      sr4::RouterTX::AckCancelExtRouter const *, msg
      ),
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_integer( uint64_t, siid, siid_arg )
      ctf_integer( uint64_t, iid, msg->iid() )
      ctf_integer( uint64_t, cid, msg->cid() )
      ctf_integer( uint64_t, tid, msg->tid() )
      ctf_integer( uint64_t, eoid, msg->eoid() )
      ctf_integer( uint64_t, side, msg->side() )
      ctf_integer( uint64_t, cxl_qty,  msg->cxl_qty() )
      )
   )

TRACEPOINT_EVENT(
   examplelib,
   cancel_nack,
   TP_ARGS(
      int, lineno_arg,
      uint64_t, siid_arg,
      sr4::RouterTX::NakCancel const *, msg
      ),
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_integer( uint64_t, siid, siid_arg )
      ctf_integer( uint64_t, iid, msg->iid() )
      ctf_integer( uint64_t, cid, msg->cid() )
      ctf_integer( uint64_t, tid, msg->tid() )
      ctf_integer( uint64_t, eoid, msg->eoid() )
      ctf_integer( uint64_t, side, msg->side() )
      ctf_integer( uint64_t, reason_code, msg->reason_code() )
      )
   )

TRACEPOINT_EVENT(
   examplelib,
   fill,
   TP_ARGS(
      int, lineno_arg,
      uint64_t, siid_arg,
      sr4::RouterTX::EvtFillRouter const *, msg
      ),
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_integer( uint64_t, siid, siid_arg )
      ctf_integer( uint64_t, iid, msg->iid() )
      ctf_integer( uint64_t, cid, msg->cid() )
      ctf_integer( uint64_t, tid, msg->tid() )
      ctf_integer( uint64_t, eoid, msg->eoid() )
      ctf_integer( uint64_t, side, msg->side() )
      )
   )

TRACEPOINT_EVENT(
   examplelib,
   killed,
   TP_ARGS(
      int, lineno_arg,
      uint64_t, siid_arg,
      sr4::RouterTX::EvtOrderKilledRouter const *, msg
      ),
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_integer( uint64_t, siid, siid_arg )
      ctf_integer( uint64_t, iid, msg->iid() )
      ctf_integer( uint64_t, cid, msg->cid() )
      ctf_integer( uint64_t, tid, msg->tid() )
      ctf_integer( uint64_t, eoid, msg->eoid() )
      ctf_integer( uint64_t, side, msg->side() )
      )
   )

TRACEPOINT_EVENT(
   examplelib,
   created,
   TP_ARGS(
      int, lineno_arg,
      uint64_t, siid_arg,
      sr4::RouterTX::EvtOrderCreatedRouter const *, msg
      ),
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_integer( uint64_t, siid, siid_arg )
      ctf_integer( uint64_t, iid, msg->iid() )
      ctf_integer( uint64_t, cid, msg->cid() )
      ctf_integer( uint64_t, tid, msg->tid() )
      ctf_integer( uint64_t, eoid, msg->eoid() )
      ctf_integer( uint64_t, side, msg->side() )
      )
   )

TRACEPOINT_LOGLEVEL( examplelib, submit_ack, TRACE_INFO )
TRACEPOINT_LOGLEVEL( examplelib, submit_nack, TRACE_INFO )
TRACEPOINT_LOGLEVEL( examplelib, modify_ack, TRACE_INFO )
TRACEPOINT_LOGLEVEL( examplelib, modify_nack, TRACE_INFO )
TRACEPOINT_LOGLEVEL( examplelib, cancel_ack, TRACE_INFO )
TRACEPOINT_LOGLEVEL( examplelib, cancel_nack, TRACE_INFO )
TRACEPOINT_LOGLEVEL( examplelib, fill, TRACE_INFO )
TRACEPOINT_LOGLEVEL( examplelib, killed, TRACE_INFO )
TRACEPOINT_LOGLEVEL( examplelib, created, TRACE_INFO )

#define EXAMPLELIB_ONE_CSTRING_ARG_ARGS    \
   TP_ARGS( \
           int, lineno_arg, \
      char const *, param_arg \
   )

TRACEPOINT_EVENT_CLASS(
   examplelib,
   one_cstring_param_class,
   EXAMPLELIB_ONE_CSTRING_ARG_ARGS,
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_string( parameter, param_arg )
      )
   )

#define EXAMPLELIB_1S_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_EVENT_INSTANCE( \
      examplelib, \
      one_cstring_param_class, \
      name, \
      EXAMPLELIB_ONE_CSTRING_ARG_ARGS \
      )

#define EXAMPLELIB_1S_EVENT( name, level  ) \
   EXAMPLELIB_1S_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_LOGLEVEL( examplelib, name, level )

#define EXAMPLELIB_ONE_UINT_ARG_ARGS \
   TP_ARGS( \
      int, lineno_arg,     \
      uint64_t, param_arg \
   )

TRACEPOINT_EVENT_CLASS(
   examplelib,
   one_uint_param_class,
   EXAMPLELIB_ONE_UINT_ARG_ARGS,
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_integer( uint64_t, parameter, param_arg )
      )
   )

#define EXAMPLELIB_1U_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_EVENT_INSTANCE( \
      examplelib, \
      one_uint_param_class, \
      name, \
      EXAMPLELIB_ONE_UINT_ARG_ARGS \
      )

#define EXAMPLELIB_1U_EVENT( name, level ) \
   EXAMPLELIB_1U_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_LOGLEVEL( examplelib, name, level )

#define EXAMPLELIB_TWO_UINT_ARG_ARGS \
   TP_ARGS( \
      int, lineno_arg, \
      uint64_t, param1_arg, \
      uint64_t, param2_arg \
   )

TRACEPOINT_EVENT_CLASS(
   examplelib,
   two_uint_param_class,
   EXAMPLELIB_TWO_UINT_ARG_ARGS,
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_integer( uint64_t, parameter1, param1_arg )
      ctf_integer( uint64_t, parameter2, param2_arg )
      )
   )

#define EXAMPLELIB_TWO_CSTRING_ARG_ARGS    \
   TP_ARGS( \
           int, lineno_arg, \
           char const *, param_arg, \
           char const *, param2_arg \
   )

TRACEPOINT_EVENT_CLASS(
   examplelib,
   two_cstring_param_class,
   EXAMPLELIB_TWO_CSTRING_ARG_ARGS,
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_string( parameter, param_arg )
      ctf_string( parameter2, param2_arg )
      )
   )

#define EXAMPLELIB_2S_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_EVENT_INSTANCE( \
      examplelib, \
      two_cstring_param_class, \
      name, \
      EXAMPLELIB_TWO_CSTRING_ARG_ARGS \
      )

#define EXAMPLELIB_2S_EVENT( name, level  ) \
   EXAMPLELIB_2S_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_LOGLEVEL( examplelib, name, level )

#define EXAMPLELIB_2U_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_EVENT_INSTANCE( \
      examplelib, \
      two_uint_param_class, \
      name, \
      EXAMPLELIB_TWO_UINT_ARG_ARGS \
      )

#define EXAMPLELIB_2U_EVENT( name, level ) \
   EXAMPLELIB_2U_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_LOGLEVEL( examplelib, name, level )

#define EXAMPLELIB_SU_ARG_ARGS \
   TP_ARGS( \
      int, lineno_arg, \
      char const *, param1_arg, \
      uint64_t, param2_arg \
   )

TRACEPOINT_EVENT_CLASS(
   examplelib,
   string_uint_param_class,
   EXAMPLELIB_SU_ARG_ARGS,
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_string( parameter1, param1_arg )
      ctf_integer( uint64_t, parameter2, param2_arg )
      )
   )

#define EXAMPLELIB_SU_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_EVENT_INSTANCE( \
      examplelib, \
      string_uint_param_class, \
      name, \
      EXAMPLELIB_SU_ARG_ARGS \
      )

#define EXAMPLELIB_SU_EVENT( name, level ) \
   EXAMPLELIB_SU_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_LOGLEVEL( examplelib, name, level )

#define EXAMPLELIB_THREE_UINT_ARG_ARGS \
   TP_ARGS( \
      int, lineno_arg, \
      uint64_t, param1_arg, \
      uint64_t, param2_arg, \
      uint64_t, param3_arg \
)

TRACEPOINT_EVENT_CLASS(
   examplelib,
   siid_iid_eid_class,
   EXAMPLELIB_THREE_UINT_ARG_ARGS,
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_integer( uint64_t, siid, param1_arg )
      ctf_integer( uint64_t, iid, param2_arg )
      ctf_integer( uint64_t, eid, param3_arg )
      )
   )

#define EXAMPLELIB_SIE_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_EVENT_INSTANCE( \
      examplelib, \
      siid_iid_eid_class, \
      name, \
      EXAMPLELIB_THREE_UINT_ARG_ARGS \
      )

#define EXAMPLELIB_SIE_EVENT( name, level ) \
   EXAMPLELIB_SIE_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_LOGLEVEL( examplelib, name, level )

TRACEPOINT_EVENT_CLASS(
   examplelib,
   three_uint_param_class,
   EXAMPLELIB_THREE_UINT_ARG_ARGS,
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_integer( uint64_t, siid, param1_arg )
      ctf_integer( uint64_t, iid, param2_arg )
      ctf_integer( uint64_t, eid, param3_arg )
      )
   )

#define EXAMPLELIB_3U_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_EVENT_INSTANCE( \
      examplelib, \
      three_uint_param_class, \
      name, \
      EXAMPLELIB_THREE_UINT_ARG_ARGS \
      )

#define EXAMPLELIB_3U_EVENT( name, level ) \
   EXAMPLELIB_3U_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_LOGLEVEL( examplelib, name, level )

#define EXAMPLELIB_UUC_ARG_ARGS \
   TP_ARGS( \
      int, lineno_arg, \
      uint64_t, param1_arg, \
      uint64_t, param2_arg, \
      char, param3_arg \
)

TRACEPOINT_EVENT_CLASS(
   examplelib,
   uint_uint_char_class,
   EXAMPLELIB_UUC_ARG_ARGS,
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_integer( uint64_t, param1, param1_arg )
      ctf_integer( uint64_t, param2, param2_arg )
      ctf_integer( uint8_t, param3, param3_arg )
      )
   )

#define EXAMPLELIB_UUC_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_EVENT_INSTANCE( \
      examplelib, \
      uint_uint_char_class, \
      name, \
      EXAMPLELIB_UUC_ARG_ARGS \
      )

#define EXAMPLELIB_UUC_EVENT( name, level ) \
   EXAMPLELIB_UUC_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_LOGLEVEL( examplelib, name, level )

#define EXAMPLELIB_3US_ARG_ARGS \
   TP_ARGS( \
      int, lineno_arg, \
      uint64_t, param1_arg, \
      uint64_t, param2_arg, \
      uint64_t, param3_arg, \
      char const *, param4_arg \
)

TRACEPOINT_EVENT_CLASS(
   examplelib,
   uint3_string_class,
   EXAMPLELIB_3US_ARG_ARGS,
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_integer( uint64_t, param1, param1_arg )
      ctf_integer( uint64_t, param2, param2_arg )
      ctf_integer( uint64_t, param3, param3_arg )
      ctf_string( param4, param4_arg )
      )
   )

#define EXAMPLELIB_3US_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_EVENT_INSTANCE( \
      examplelib, \
      uint3_string_class, \
      name, \
      EXAMPLELIB_3US_ARG_ARGS \
      )

#define EXAMPLELIB_3US_EVENT( name, level ) \
   EXAMPLELIB_3US_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_LOGLEVEL( examplelib, name, level )

#define EXAMPLELIB_UUS_ARG_ARGS \
   TP_ARGS( \
      int, lineno_arg, \
      uint64_t, param1_arg, \
      uint64_t, param2_arg, \
      char const *, param3_arg \
)

TRACEPOINT_EVENT_CLASS(
   examplelib,
   uint_uint_string_class,
   EXAMPLELIB_UUS_ARG_ARGS,
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_integer( uint64_t, param1, param1_arg )
      ctf_integer( uint64_t, param2, param2_arg )
      ctf_string( param3, param3_arg )
      )
   )

#define EXAMPLELIB_UUS_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_EVENT_INSTANCE( \
      examplelib, \
      uint_uint_string_class, \
      name, \
      EXAMPLELIB_UUS_ARG_ARGS \
      )

#define EXAMPLELIB_UUS_EVENT( name, level ) \
   EXAMPLELIB_UUS_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_LOGLEVEL( examplelib, name, level )

#define EXAMPLELIB_FIVE_UINT_ARG_ARGS \
   TP_ARGS( \
      int, lineno_arg, \
      uint64_t, param1_arg, \
      uint64_t, param2_arg, \
      uint64_t, param3_arg, \
      uint64_t, param4_arg, \
      uint64_t, param5_arg \
   )

TRACEPOINT_EVENT_CLASS(
   examplelib,
   five_uint_param_class,
   EXAMPLELIB_FIVE_UINT_ARG_ARGS,
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_integer( uint64_t, parameter1, param1_arg )
      ctf_integer( uint64_t, parameter2, param2_arg )
      ctf_integer( uint64_t, parameter3, param3_arg )
      ctf_integer( uint64_t, parameter4, param4_arg )
      ctf_integer( uint64_t, parameter5, param5_arg )
      )
   )

#define EXAMPLELIB_5U_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_EVENT_INSTANCE( \
      examplelib, \
      five_uint_param_class, \
      name, \
      EXAMPLELIB_FIVE_UINT_ARG_ARGS \
      )

#define EXAMPLELIB_5U_EVENT( name, level ) \
   EXAMPLELIB_5U_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_LOGLEVEL( examplelib, name, level )

#define EXAMPLELIB_SIX_UINT_ARG_ARGS \
   TP_ARGS( \
      int, lineno_arg, \
      uint64_t, param1_arg, \
      uint64_t, param2_arg, \
      uint64_t, param3_arg, \
      uint64_t, param4_arg, \
      uint64_t, param5_arg, \
      uint64_t, param6_arg \
   )

TRACEPOINT_EVENT_CLASS(
   examplelib,
   six_uint_param_class,
   EXAMPLELIB_SIX_UINT_ARG_ARGS,
   TP_FIELDS(
      ctf_integer( int, source_line, lineno_arg )
      ctf_integer( uint64_t, parameter1, param1_arg )
      ctf_integer( uint64_t, parameter2, param2_arg )
      ctf_integer( uint64_t, parameter3, param3_arg )
      ctf_integer( uint64_t, parameter4, param4_arg )
      ctf_integer( uint64_t, parameter5, param5_arg )
      ctf_integer( uint64_t, parameter6, param6_arg )
      )
   )

#define EXAMPLELIB_6U_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_EVENT_INSTANCE( \
      examplelib, \
      six_uint_param_class, \
      name, \
      EXAMPLELIB_SIX_UINT_ARG_ARGS \
      )

#define EXAMPLELIB_6U_EVENT( name, level ) \
   EXAMPLELIB_6U_TRACEPOINT_INSTANCE( name ) \
   TRACEPOINT_LOGLEVEL( examplelib, name, level )

EXAMPLELIB_1U_EVENT( received_config, TRACE_INFO )
EXAMPLELIB_1U_EVENT( number_of_legs, TRACE_INFO )
EXAMPLELIB_1U_EVENT( mass_cancel_request, TRACE_INFO )
EXAMPLELIB_1U_EVENT( update_without_initial, TRACE_WARNING )

EXAMPLELIB_1S_EVENT( stopping_unloading, TRACE_INFO )
EXAMPLELIB_1S_EVENT( client_connected, TRACE_INFO )
EXAMPLELIB_1S_EVENT( client_disconnected, TRACE_INFO )

EXAMPLELIB_2U_EVENT( set_leg_offset, TRACE_INFO )
EXAMPLELIB_2U_EVENT( set_leg_seed_levels, TRACE_INFO )
EXAMPLELIB_2U_EVENT( set_legs_order_multiple, TRACE_INFO )
EXAMPLELIB_2U_EVENT( set_leg_reseed_delay, TRACE_INFO )
EXAMPLELIB_2U_EVENT( set_leg_stack_orders, TRACE_INFO )
EXAMPLELIB_2U_EVENT( legs_not_constructed_yet, TRACE_INFO )

EXAMPLELIB_SU_EVENT( symbol_leg_count, TRACE_INFO )
EXAMPLELIB_SU_EVENT( exchange_leg_count, TRACE_INFO )
EXAMPLELIB_SU_EVENT( unhandled_name_leg, TRACE_WARNING )
EXAMPLELIB_SU_EVENT( attempting_to_start, TRACE_INFO )
EXAMPLELIB_SU_EVENT( stopping, TRACE_INFO )

EXAMPLELIB_3U_EVENT( feeder_subscribe_response, TRACE_INFO )
EXAMPLELIB_3U_EVENT( feeder_unsubscribe_response, TRACE_INFO )
EXAMPLELIB_3U_EVENT( feeder_status_ok, TRACE_INFO )
EXAMPLELIB_3U_EVENT( feeder_not_ok, TRACE_WARNING )
EXAMPLELIB_3U_EVENT( order_out_of_range, TRACE_WARNING )

EXAMPLELIB_UUS_EVENT( unknown_variable, TRACE_WARNING )
EXAMPLELIB_UUS_EVENT( router_subscribed, TRACE_INFO )
EXAMPLELIB_UUS_EVENT( feeder_subscribe, TRACE_INFO )

EXAMPLELIB_3US_EVENT( rejected_update, TRACE_WARNING )
EXAMPLELIB_3US_EVENT( updated, TRACE_INFO )

EXAMPLELIB_5U_EVENT( inserting_order_in_pricebook, TRACE_INFO )

#define EXLOG( event, param ) tracepoint( examplelib, event, __LINE__, param )
#define EXLOG2( event, param1, param2 ) tracepoint( examplelib, event, __LINE__, param1, param2 )
#define EXLOG3( event, param1, param2, param3 ) tracepoint( examplelib, event, __LINE__, param1, param2, param3 )
#define EXLOG4( event, param1, param2, param3, param4 ) tracepoint( examplelib, event, __LINE__, param1, param2, param3, param4 )
#define EXLOG5( event, param1, param2, param3, param4, param5 ) tracepoint( examplelib, event, __LINE__, param1, param2, param3, param4, param5 )
#define EXLOG6( event, param1, param2, param3, param4, param5, param6 ) tracepoint( examplelib, event, __LINE__, param1, param2, param3, param4, param5, param6 )
#endif

#undef TRACEPOINT_INCLUDE
#define TRACEPOINT_INCLUDE "tp_examplelib.h"

#include <lttng/tracepoint-event.h>
